/*
 * FITSParameters.h
 *
 *  Created on: Sep 22, 2010
 *      Author: Brenda Javornik (e-mail: brendaj (at) nwra.com)
 */

#ifndef FITSPARAMETERS_H_
#define FITSPARAMETERS_H_

#define MAX_FITS_PARM_VALUE 21
#define MAX_FITS_PARMS		 4  // Related to NUM_PARAMETERS in Parameters.h
#define MAX_CARD_LENGTH_FOR_FITS	80

/**
 * Parameters written to the header of output FITS files.
 * @ingroup FITSParameters
 */
typedef struct {
	int n;												///< number of parameters to write; maximum is MAX_FITS_PARMS
	char *names[MAX_FITS_PARMS];						///< name of parameter
	char *comments[MAX_FITS_PARMS];						///< comment for parameter
	char scientificNotation[MAX_FITS_PARMS][MAX_FITS_PARM_VALUE];  ///< parameter value as a string in scientific notation
} FITSParameters;

struct FITSParamConstants {
	 char *sciFiFormat;  // sprintf format string to use for FITS header parameters
};

static const struct FITSParamConstants FITSParametersConstants = {
		"%20E"
};

#endif /* FITSPARAMETERS_H_ */
