/*
 * MatrixFunctionErrorMessages.h
 *
 *  Created on: Feb 28, 2011
 *      Author: Brenda Javornik (e-mail: brendaj (at) nwra.com)
 */

#ifndef MATRIXFUNCTIONERRORMESSAGES_H_
#define MATRIXFUNCTIONERRORMESSAGES_H_

const static char FileOpenError[] = "Could not open file";
const static char UnsupportedFitsFormat[] = "Only 1D or 2D images are supported";
const static char DGESVFailed[] = "dgesv_ fails";
const static char DGETRFFailed[] = "Error computing LU factorization of matrix: dgetrf_ failed";
const static char DGETRIFailed[] = "Error computing inverse of matrix: dgetri_ failed";
const static char DGETRSFailed[] = "Error solving system of linear equations: dgetrs_ failed";
const static char DPOTRFFailed[] = "Error computing Cholesky factorization of matrix: dpotrf_ failed";
const static char LinearEqSolveExpectedColVector[] = "not a column vector as expected";
const static char ToVectorFailes[] = "Unable to convert fits2d to vector because both dimensions are greater than 1. ";
const static char DivByZero[] = "Operation causes division by zero. ";
const static char LinearEqSolveFirst[] = "LUDecomp is Null. Must call linearEqSolve prior to LinearEqSolveNRHS to calculate LUDecomp";
const static char RealMatrixExpected[] = "Expected a Real matrix";
const static char ComplexMatrixExpected[] = "Expected a Complex matrix";
const static char FftwShiftNoComplexData[] = "fftwShift not implemented for complex data";
const static char matrixMultipyMMIncompatibleMatrixSizes[] = "Columns of Matrix A are not compatible with Rows of Matrix B";
const static char matrixMultipyMMUnknownMatrixTypes[] = "unknown combination of matrix types";
const static char MatrixAPlusLambdaBNotImplCombination[] = "code not implemented to handle COMPLEX, REAL variation";
const static char MatrixAPlusLambdaBMatricesNotSameSize[] = "matrices are not compatible; they must all be the same size";
const static char MatrixNorm2NotImpl[] = "not implemented for Real Matrices";
const static char MatrixConvertToRealNotComplex[] = "matrix is not complex";
const static char MatrixConvertToComplexNotReal[] = "matrix is not real";
const static char MatrixComplexNotImpl[] = "not implemented for Complex Matrices";
const static char MatrixConvertToRealConvFail[] = "conversion failed";
const static char MatrixMatrixToVectorComplexNotImpl[] = "Conversion from COMPLEX matrix to complex vector not implemented";
const static char MatrixMatrixToVectorNoRowOrColVec[] = "Cannot convert matrix to vector; matrix is neither a column nor row vector";
const static char MatrixUnrecognizedOperator[] = "Unrecognized operator.  Expected 'N', 'C', or 'T'.";

const static char MapDepthMatrixReadUnexpectedDim[] = "Unexpected dimensions on fits file";
const static char MapDepthMatrixBadInsert[] = "cannot insert the 2d matrix into 4d matrix";
const static char MapDepthMatrixNotEnoughFilenames[] = "Not enough filenames to print MapDepthMatrix";

const static char ReadWriteFitsBadZDimension[] = "The specified plane is outside the range for Z-Dimension";
const static char ReadWriteFitsBadTDimension[] = "The specified plane is outside the range for T-Dimension";
const static char WriteFitsFileNotOpen[] = "Must open FITS file before writing to it";
const static char WriteFitsHeaderError[] = "Error writing header parameters to fits file";
const static char ReadFitsFileBadDimensions[] = "Expected 1D, 2D or 3D image; instead, opened FITS file with dimensions";
const static char MatrixNoConjugateReal[] = "cannot take conjugate of Real matrix";
const static char MatrixIncompatibleSizes[] = "Incompatible matrix sizes";
const static char MatrixStarMultiplySameSize[] = "Operands must have same number of rows and columns";
const static char MatrixStarMultiplySameType[] = "no mixed matrix types";
const static char MatrixBiggerDim[] = "New dimensions must be bigger than current matrix dimensions";
const static char MatrixEmbedEvenDim[] = "must have Nx == Ny and even";

const static char SuperYAvgKNoiseExceed[] = "Cannot pack super vectorY, Averaging Kernel and Noise exceed the size of superY";
const static char SuperYAvgKIToReal[] = "Could not convert averaging kernel from complex to real";
const static char SuperYNoiseIToReal[] = "Could not convert noise from complex to real";
const static char SuperYCannotConvertCToI[] = "Cannot convert from complex to real; imaginary part is not zero at element %1d: %f + %fi\n";
const static char SuperYRDataNull[] = "rData is NULL";
const static char SuperYCDataNull[] = "cData is NULL";
const static char MaskReadUnexpectedDim[] = "Unexpected dimensions on fits file";
const static char FftwSystemWisdomImport[] = "Error importing system wisdom";
const static char FftwWisdomImport[] = "Unable to open wisdom file";
const static char FftwWisdomRead[] = "Unable to read wisdom file";
const static char FftwWisdomWrite[] = "Unable to open wisdom file for writing";
const static char FftwForwardPlanNull[] = "Unable to generate forward plan using wisdom";
const static char FftwReversePlanNull[] = "Unable to generate reverse plan using wisdom";
#endif /* MATRIXFUNCTIONERRORMESSAGES_H_ */
