/*
 * lambda.h
 *
 *  Created on: Apr 30, 2010
 *      Author: Brenda Javornik (e-mail: brendaj (at) nwra.com)
 */

#ifndef LAMBDA_H_
#define LAMBDA_H_

#include "InvTypes.h"

/**
 * LambdaSet contains specifications for a range of lambda
 * values.
 * @ingroup LambdaSet
 */
typedef struct {
	Float min; ///< minimum value
	Float max; ///< maximum value
	int n; 		///< number of steps including min and max
	int log;	///< 0 if linear steps, != 0 if log steps
	Float base;
	Float mantissa;
} LambdaSet;

LambdaSet *newLambdaSet(Float min, Float max, int linearSteps, int logStep);

void freeLambdaSet(LambdaSet *ls);

Float nextLambdaValue(LambdaSet lambdaSet, int n);

#endif /* LAMBDA_H_ */
