/*
 * utilities.h
 *
 *  Created on: May 24, 2010
 *      Author: Brenda Javornik (e-mail: brendaj (at) nwra.com)
 */

#ifndef UTILITIES_H_
#define UTILITIES_H_

#include <stdlib.h>
#include <stdbool.h>
#include <dirent.h>
#include "coreVersion.h"

#define ROW_MAJOR_IDX(R, C, NCOL) ((R)*(NCOL) + (C))

#define min(a,b) ((a)>(b)?(b):(a))
#define max(a,b) ((a)>(b)?(a):(b))

bool endsWith(char *string, char *ending);
char *strip(char *aString);
int longestName(char *filenames[], int nFiles);
bool lowerStrNCmp(const char *str1, const char *str2, int n);

/* string tokenizer */
void stringTokenizer(char *line);
char *nextToken();

char *constructFileName(char *basedir, const char *filename);

char *td_malloc(size_t size);

void td_free(void *mem, size_t size);
long getMemoryReport();

DIR  *exists(const char *name);

bool isWritable(char *pathname);

bool isReadable(char *pathname);

void copyFiles(const char *source, const char *dest);

char *getNextEmptyDirectory(char *baseDir);

DIR *getDirectoryR(char *dirName);
DIR *getDirectory(char *dirName);

char *getParent(char *path);
void getParentNChild(char *path, char **parent, char **child);

#endif /* UTILITIES_H_ */
