
%{
#include <stdio.h>
#include <string.h>

#include "myptypes.h"

#define YYSTYPE char *

#include "inversion.tab.h"

extern YYLTYPE yylloc;

char *p;

%}

%%
[Aa]vg      return T_AVG;
[Kk]ernel   return T_KERN;
1d			return T_1D;
2d			return T_2D;
3d_scalar	return T_3D;
3d_vector	return T_3D_V;
3d_vector_x	return T_3D_VX;
3d_vector_y	return T_3D_VY;
3d_vector_z	return T_3D_VZ;
lsqr 		return T_LSQR;
clsqr 		return T_CLSQR;
ola			return T_OLA;
rls			return T_RLS;
forward		return T_FORWARD;
calcq       return T_CALCQ;
log	        return T_LOG;
[Ss]eed	    return T_SEED;

[-+]?[0-9]+		{ 
			  p=(char *)malloc((strlen(yytext)+1) * sizeof(char));
			  strcpy(p,yytext);
			  yylval=p;
			  return T_INTEGER; }
[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?	{ 
			  p=(char *)malloc((strlen(yytext)+1) * sizeof(char));
			  strcpy(p,yytext);
			  yylval=p;
			  return T_REAL; }
[a-zA-Z0-9\/.\-_~]+        { 
			  p=(char *)malloc((strlen(yytext)+1) * sizeof(char));
			  strcpy(p,yytext);
			  yylval=p;
			  return T_FILENAME; }
^[!%][^\r\n]*[\n] /* ignore comments */ { yylloc.first_line += 1; }
\n                       {
			  yylloc.first_line += 1;
			  return EOL; } /* don't ignore end of line */;
[ \t]+                  /* ignore whitespace */;

%%
