/*
 * parserErrorMessages.h
 *
 *  Created on: Feb 15, 2011
 *      Author: Brenda Javornik (e-mail: brendaj (at) nwra.com)
 */

#ifndef PARSERERRORMESSAGES_H_
#define PARSERERRORMESSAGES_H_

const static char Missing1dTargetFunc[] = "Expected 1D target function, f(z; z0)";
const static char MissingThetaFile[] = "Expected theta (overlap) file";
const static char MissingProblemDefn[] = "Expected problem definition";
const static char MissingBaseDir[] = "Expecting base directory";
const static char MissingKernBaseDir[] = "Expecting kernel base directory";
const static char MissingMapBaseDir[] = "Expecting map base directory";
const static char MissingMaskBaseDir[] = "Expecting mask base directory";
const static char MissingCovarFile[] = "Expecting covariance file";
const static char MissingMapFile[] = "Expecting map file";
const static char MissingKernFile[] = "Expecting kernel file";
const static char MissingMaskFile[] = "Expecting mask file";
const static char MissingRegFile[] = "Expecting regularization file";
const static char MissingKernMapPairs[] = "Expecting kernel-map pairs";
const static char MissingLambdaRange[] = "Expecting range for lambda parameter(s)";
const static char MissingMuSigmaRange[] = "Expecting range for mu and sigma parameters";
const static char MissingAvgKern[] = "Expecting averaging kernel specification";
const static char MissingSeedOrNoiseScale[] = "Expecting unsigned integer for random seed or range for noise scale (MissingSeedOrNoiseScale)";
const static char UnsignedIntForSeed[] = "Random seed must be an unsigned integer (UnsignedIntForSeed)";
const static char FoundSeedMsg[] = "found random number generator seed";
const static char FoundInitialGuessMsg[] = "Initial guess file";
const static char InputFileOpenedMsg[] = "Input file opened";
const static char InputFileOpenFailedMsg[] = "Cannot open input file";

const static char CannotOpenInputDataFileMsg[] = "Error opening file %s: %s\n\n";
const static char BadProblemDim[] = "unrecognized Problem Dimension, %s, expected %s, %s, %s or %s.";
const static char OBDCreateFail[] = "creating output Base Dir ";
const static char OBDCreateOk[] = "Output base directory successfully created";
const static char OBDNoWrite[] = "output Base Dir is not writable or accessible:  %s";
const static char dFileNoExist[] = "input map file does not exist:  %s";
const static char maskFileNoExist[] = "input mask file does not exist:  %s";
const static char CIFileNoExist[] = "noise covariance file does not exist:  %s";
const static char ModelFileNoExist[] = "model file does not exist:  %s";
const static char KFileNoExist[] = "kernel file does not exist:  %s";
const static char RFileNoExist[] = "Regularization file does not exist:  %s";
const static char TargetFNoExist[] = "Target 1D file does not exist:  %s";
const static char DirCreateFail[] = "creating Directory ";
const static char DirCreateOk[] = "Directory successfully created";

const static char KernelBaseDirNoExist[] = "base directory for Kernel files does not exist  %s";
const static char MapBaseDirNoExist[] = "base directory for Map files does not exist  %s";
const static char MaskBaseDirNoExist[] = "base directory for Mask files does not exist  %s";
const static char AvgKerLineExpected[] = "Avg Kernel line expected instead of  0}";
const static char AvgStrExpected[] = "keyword Avg expected instead of  %s";
const static char KernelStrExpected[] = "keyword Kernel expected instead of  %s";
const static char ExpectedPositiveInteger[] = "expected positive integer for Averaging Kernel depth instead of";
const static char ExtraCharsAfterMinus1[] = "extra characters after -1 in Averaging Kernel specification";
const static char AvgKernSpecTooLong[] = "Averaging kernel specification is too long. Max characters is ";

const static char RangeMinGreaterMax[] = "RangeMinGreaterMaxError, Range min must be <= Range max: Found Range min = ";
const static char RangeNLessEqZero[] = "RangeNLessEqZeroError, Number of steps in range must be greater than zero: Found ";
const static char LambdaNotEnough[] = "LambdaNotEnoughError, missing range specification for Lambda. \n\tFound: %s \texpected: Lambda1Min Lambda1Max nLambda1 Lambda2Min Lambda2Max nLambda2.";
const static char MuNotEnough[] = "MuNotEnoughError, missing range specification for Mu and Sigma. \n\tFound: %s \texpected: muMin muMax nMu sigmaMin sigmaMax nSigma.";

const static char ParsingOnlyMsg[] = "Parsing file only";
const static char CopyAllInputMsg[] = "Will copy all input files to output base directory";
const static char OlaInversionMsg[] = "Performing OLA inversion";
const static char RlsInversionMsg[] = "Performing RLS inversion";
const static char UnrecognizedInversion[] = "Unrecognized type of inversion";

const static char ErrorsExiting[] = "Errors found in the input data file. Exiting.";
const static char ParsingOnly[] = "Only parsing file; Inversion not run. Exiting.";
const static char SolvingInversion[] = "Solving Inversion ... ";
const static char DebugFlag[] = "Debug flag detected.";

const static char SuccessfulInversion[] = "The inversion completed successfully.";
const static char ExceptionInversion[] = "The inversion had an exception.";
const static char CompletedWithError[] = "The inversion completed with error. %s";

#endif /* PARSERERRORMESSAGES_H_ */
